/*

(C) 2009 Mika Ilmaranta <ilmis@nullnet.fi>

License: GPLv2

*/


#ifndef __CONFIG_H__
#define __CONFIG_H__

typedef struct config {
	struct config *prev, *next;
	char *name;
	char *checkip;
	char *eventscript;
	int max_packet_loss;
	int max_successive_pkts_lost;
	int min_packet_loss;
	int min_successive_pkts_rcvd;
	int interval_ms;
	int timeout_ms;
	char *warn_email;
	int check_arp;
	char *sourceip;
	char *device;
	int ttl;
	int status;

	void *data;
} CONFIG;

typedef struct group_members {
	struct group_members *prev, *next;
	char *name;
	CONFIG *cfg_ptr;
} GROUP_MEMBERS;

typedef struct groups {
	struct groups *prev, *next;
	char *name;
	char *eventscript;
	char *warn_email;
	int logic; /* or = 0, and = 1 */
	int status;
	GROUP_MEMBERS *fgm, *lgm;
} GROUPS;

typedef struct global {
	int debug;
	int reopen_on_enodev;
} GLOBAL;

extern GLOBAL cfg;

int read_config(char *fn, CONFIG **first, CONFIG **last, GROUPS **firstg, GROUPS **lastg);
int reload_config(char *fn, CONFIG **first, CONFIG **last, GROUPS **firstg, GROUPS **lastg);
void dump_config(CONFIG **first, CONFIG **last, GROUPS **firstg, GROUPS **lastg);
void free_config(CONFIG **first, CONFIG **last, GROUPS **firstg, GROUPS **lastg);

#endif

/* EOF */
