/*

(C) 2009 Mika Ilmaranta <ilmis@nullnet.fi>

License: GPLv2

*/

#include <stdio.h>

#include "icmp_t.h"

static char *icmp_type_str[MAX_ICMP_TYPE] = {
	 "ICMP Echo Reply",              /* 0 */
	 "",
	 "",
	 "ICMP Unreachable",             /* 3 */
	 "ICMP Source Quench",           /* 4 */
	 "ICMP Redirect",                /* 5 */
	 "",
	 "",
	 "ICMP Echo",                    /* 8 */
	 "",
	 "",
	 "ICMP Time Exceeded",           /* 11 */
	 "ICMP Paramter Problem",        /* 12 */
	 "ICMP Timestamp Request",       /* 13 */
	 "ICMP Timestamp Reply",         /* 14 */
	 "ICMP Information Request",     /* 15 */
	 "ICMP Information Reply",       /* 16 */
	 "ICMP Mask Request",            /* 17 */
	 "ICMP Mask Reply"               /* 18 */
 };

static char *icmp_unreach_str[MAX_ICMP_CODE] = {
	"ICMP Network Unreachable",                                     /* 0 */
	"ICMP Host Unreachable",                                        /* 1 */
	"ICMP Protocol Unreachable",                                    /* 2 */
	"ICMP Port Unreachable",                                        /* 3 */
	"ICMP Unreachable (Fragmentation Needed)",                      /* 4 */
	"ICMP Unreachable (Source Route Failed)",                       /* 5 */
	"ICMP Unreachable (Destination Network Unknown)",               /* 6 */
	"ICMP Unreachable (Destination Host Unknown)",                  /* 7 */
	"ICMP Unreachable (Source Host Isolated)",                      /* 8 */
	"ICMP Unreachable (Communication with Network Prohibited)",     /* 9 */
	"ICMP Unreachable (Communication with Host Prohibited)",        /* 10 */
	"ICMP Unreachable (Network Unreachable For Type Of Service)",   /* 11 */
	"ICMP Unreachable (Host Unreachable For Type Of Service)",      /* 12 */
	"ICMP Unreachable (Communication Administratively Prohibited)", /* 13 */
	"ICMP Unreachable (Host Precedence Violation)",                 /* 14 */
	"ICMP Unreachable (Precedence cutoff in effect)"                /* 15 */
};

char *stricmptype(int icmp_type)
{
	return(icmp_type < MAX_ICMP_TYPE ? icmp_type_str[icmp_type] : NULL);
}

char *stricmpcode(int icmp_code)
{
	return(icmp_code < MAX_ICMP_CODE ? icmp_unreach_str[icmp_code] : NULL);
}


/* EOF */
